#import "/src/cetz.typ": draw

#import "/src/core/utils.typ": normalize-measure
#import "/src/consts.typ": *

#let name = "entity"

#let render(x, y, p, bottom) = {
  let m = measure(p.display-name)
  let style = p.resolved-style
  let r = ENTITY-HEIGHT / 2
  let y0 = if bottom {
    y - m.height / 1pt - SYM-GAP
  } else {
    y + m.height / 1pt + ENTITY-HEIGHT + SYM-GAP
  }
  let y1 = y0 - ENTITY-HEIGHT - 1.5

  draw.circle(
    (x, y0 - r),
    radius: r,
    fill: style.fill,
    stroke: style.stroke
  )
  draw.line(
    (x - r, y1),
    (x + r, y1),
    stroke: style.stroke
  )
  draw.content(
    (x, y),
    p.display-name,
    anchor: if bottom {"north"} else {"base"}
  )
}

#let get-size(par) = {
  let m = normalize-measure(par.display-name)

  // ENTITY-HEIGHT * 1pt
  // ENTITY-HEIGHT * 1pt + 2pt + SYM-GAP * 1pt + h

  return m
}

#let default-style = (
  :
)